// these macros are defined to keep the compatibilty with the
// orginal PCLEX code
#define yylex yyLex
#define yywrap yyWrap
#define yyleng yyLeng
#define yyText yytext
#define yy_ch_buf yyBuffer
#define yy_saw_eof yySawEndOfFil

#define YY_DEFAULT_ACTION ECHO;
#define YY_END_TOK 0
#define YY_NEW_FILE -1
#define YY_DO_DEFAULT -2
#ifndef BUFSIZ
#include <stdio.h>
#endif
#define F_BUFSIZ BUFSIZ
#define YY_BUF_SIZE (F_BUFSIZ * 2)
#define YY_BUF_MAX (YY_BUF_SIZE - 1)
#ifndef YY_MAX_LINE
#define YY_MAX_LINE F_BUFSIZ
#endif
#define YY_BUF_LIM (YY_BUF_MAX - YY_MAX_LINE)
#define ECHO (void) fwrite( (unsigned char *) yyText, yyLeng, 1, yyOutputFile )
#define YY_INPUT(buf,result,max_size) \
        if (inputType==InputFromFile) \
        { \
	    if ((result=fread((unsigned char *)buf, sizeof(unsigned char), max_size, yyInputFile)) < 0   )\
	        YY_FATAL_ERROR( "L0048: fread() in PCLEX scanner failed" ); \
        } \
        else \
        { \
            yyInputStream->read(buf,max_size); \
            fprintf(stderr,"**** %s ****\n",buf); \
            if ((result=yyInputStream->gcount())<0) \
                YY_FATAL_ERROR("L0048: istream read() in PCLEX scanner failed"); \
        }
#define YY_NULL 0
#define YY_OUTPUT(c) fputc(c, yyout);
#define YY_FATAL_ERROR(msg) \
	{ \
	fputs(msg, stderr); \
	putc('\n', stderr); \
	exit(1); \
	}
#define YY_FIRST_CHAR yyBuffer[yyBufferPtrB]
#define BEGIN yyStart = 1 +
#define YY_SET_BOL(array,pos) array[pos - 1] = '\n';
#define yyless(n) \
	{ \
	YY_DO_BEFORE_SCAN; \
	yyBufferPtrC = yyBufferPtrB + (n) - 1; \
	YY_DO_BEFORE_ACTION; \
	}
#define YY_BREAK break;
#define YY_INIT \
	{ \
	yyLeng = yyBufferPtrC = yyBufferPtrE = 0; \
	yyHoldChar = yyBuffer[yyBufferPtrC] = '\n'; \
	yyText = &yyBuffer[yyBufferPtrC]; \
	yySawEndOfFile = 0; \
	}
#define YY_LENG (yyBufferPtrC - yyBufferPtrB + 1)
#define YY_DO_BEFORE_SCAN \
	yyText[yyLeng] = yyHoldChar;
#define YY_DO_BEFORE_ACTION \
	yyText = &yyBuffer[yyBufferPtrB]; \
	yyLeng = YY_LENG; \
	yyHoldChar = yyText[yyLeng]; \
	yyText[yyLeng] = '\0';
#define REJECT \
        { \
	YY_DO_BEFORE_SCAN; \
	yyBufferPtrC = yy_full_match; \
        ++yy_lp; \
        goto find_rule; \
        }
#include <stdlib.h>
#include <iostream.h>

class ABXLex
{
    public:
        ABXLex(FILE* inputFile);    // constructor, input from file
        ABXLex(istream* inputStream);    // constructor, input from stream
        ~ABXLex();    // destructor
        int yyLex();    // lexical analyzer
        // void yyError(const File* outputFile, const char* message);
        // void yyError(const ostream* outputStream, const char* message);

    protected:
        virtual int yyWrap(void);    // can be redefined by user

    private:
        FILE *yyInputFile;
        FILE *yyOutputFile;
        istream* yyInputStream;
        enum
        {
            InputFromFile,
            InputFromStream
        } inputType;
        char *yyBuffer;
        char *yyText;
        char yyHoldChar;
        int yyBufferPtrB;
        int yyBufferPtrC;
        int yyBufferPtrE;
        int *yyStateBuffer;
        int yyStart;
        int yySawEndOfFile;
        int yyMoreFlag;
        int yyLeng;
        int yy_init;
        int input(void);
        void unput(int c);
};

