/*
=====================================================================
  MAIN.C: main routine for HTML parser
  Verion 1.0
  by Shuming Tan

  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.  
  Copyright (C) 1986-1995 by ABRAXAS SOFTWARE INC.
  
=====================================================================
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int yylineno;	   /* line # of current line, defined in lex.l*/
int yyerrcnt;       /* count of errors, defined in err_skel.c */
extern int yyparse(void);  /* defined in err_skel.c */
char yyerrsrc[128];	   /* input file name, defined in lex.l */
int c;
FILE *yyin;               /* pointer to input file */

main(int argc, char *argv[])
{
  if (argc<2)    
  {	 
    fprintf(stderr,"Usage : html <program>\n");
    exit(1);
  }
  
  yyin=fopen(argv[1],"r");
  if (yyin==0) 
  {
    fprintf(stderr,"Can't open source program file %s\n", argv[1]);
    exit(1);
  }
    
  strcpy(yyerrsrc,argv[1]);
  yylineno=1;
  c=getc(yyin);

  yyparse();
  fclose(yyin);

  if (yyerrcnt!=0)    
  {
    fprintf(stderr,"%d error%s found by the parser\n",yyerrcnt,(yyerrcnt==1)?"":"s");
  }
  else    
  {	 
    fprintf(stdout,"No syntax error was found by the parser\n");
  }
  exit(0);
}
